//+------------------------------------------------------------------+
//|                                        Bobs Magic Boxes v4.2.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//--- input parameters
input string   Box_Settings="Inputs";
input int      Min_Range=30;
input int      Max_Range=130;
input color    Box_Colour=clrBlue;
input int      Box_Width=2;
input string   Trade_Management="Inputs";
input bool     Use_Fixed_Lot = false;
input double   Fixed_Lot_Size = 0.1;
input double   Risk=1.0;
input double   N_Factor=1.0;
input double   Reward=1.0;
input int      Magic_No=1000001;
input int      Slippage=50;
extern string  Trading_Sessions ="GMT";
extern int     AsianOpen        =    0;
extern int     AsianClose       =    6;
extern int     EuropeOpen       =    6;
extern int     EuropeClose      =   12;
extern int     LondonOpen       =   12;
extern int     LondonClose      =   18;
extern int     NewYorkOpen      =   18;
extern int     NewYorkClose     =   24;
//+------------------------------------------------------------------+
//| Global variables                                                 |
//+------------------------------------------------------------------+
datetime currentbar;

int      currenthour;

double   min_range,max_range;
datetime spd2,spd3,spd4,spd5,spd6,spd7,spd8,spd9,spd10,spd11,spd12,spd13,spd14,spd15,spd16,spd17,spd18,spd19,spd20,spd21,spd22,spd23,spd24,spd25;
int      box_No,current_box,CurrentBoxType,LastBoxType;
double   AccBal,AccEqu,TickValue;

bool     NewTradeBoxFormed;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   currentbar=0;
   currenthour = 0;

   min_range= Min_Range*Point;
   max_range= Max_Range*Point;

   spd2  =  Time[4];
   spd3  =  Time[6];
   spd4  =  Time[8];
   spd5  = Time[10];
   spd6  = Time[12];
   spd7  = Time[14];
   spd8  = Time[16];
   spd9  = Time[18];
   spd10 = Time[20];
   spd11 = Time[22];
   spd12 = Time[24];
   spd13 = Time[26];
   spd14 = Time[28];
   spd15 = Time[30];
   spd16 = Time[32];
   spd17 = Time[34];
   spd18 = Time[36];
   spd19 = Time[38];
   spd20 = Time[40];
   spd21 = Time[42];
   spd22 = Time[44];
   spd23 = Time[46];
   spd24 = Time[48];
   spd25 = Time[50];

   box_No=0;
   current_box=0;
   CurrentBoxType = 1000;
   LastBoxType    = 1000;

   NewTradeBoxFormed=false;

//--- create timer
   EventSetTimer(3600);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---Set variables
   datetime time_current = TimeGMT();
   datetime thisbar      = Time[0];
   int      time_hour    = TimeHour(time_current);

   AccBal = AccountInfoDouble(ACCOUNT_BALANCE);
   AccEqu = AccountInfoDouble(ACCOUNT_EQUITY);
   TickValue=MarketInfo(Symbol(),MODE_TICKVALUE);
   
   

//+------------------------------------------------------------------+
//|   Trade Logic                                                    |
//+------------------------------------------------------------------+
//--- Activate trading hours
   bool tradetrue=((time_hour>=AsianOpen && time_hour<AsianClose) || 
                   (time_hour>=EuropeOpen && time_hour<EuropeClose)||
                   (time_hour>=LondonOpen && time_hour<LondonClose)||
                   (time_hour>=NewYorkOpen && time_hour<NewYorkClose));

//---Function 
   if(currenthour!=time_hour)
     {
      currenthour = time_hour;
      if(currenthour == 0) int ClearPreviousDayBoxes = ObjectsDeleteAll(0,OBJ_RECTANGLE);
     }

//---Function 
   if(currentbar!=thisbar)//--- New bar detector
     {
      currentbar=thisbar;
      NewTradeBoxFormed=false;
      ScanForBoxPatterns();
     }
//---Function 
//---Function
   if(NewTradeBoxFormed && tradetrue) LookForActiveTradeBox();
//---Function

//---Function 

  }
//+----------------------------------------+
//  Function Master Box                    |
//+----------------------------------------+

//+----------------------------------------+
//{
//---Reset variables

//---Initiate Function variables

//---Function Logic

//---Variable adjustments

//}
//+----------------------------------------+
//  Scan for Box Patterns                  |
//+----------------------------------------+
void ScanForBoxPatterns()
//+----------------------------------------+
  {
   RunRangeScan(iBarShift(NULL,0,spd2),3,1,2,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd3),5,2,3,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd4),7,3,4,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd5),9,4,5,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd6),11,5,6,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd7),13,6,7,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd8),15,7,8,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd9),17,8,9,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd10),19,9,10,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd11),21,10,11,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd12),23,11,12,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd13),25,12,13,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd14),27,13,14,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd15),29,14,15,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd16),31,15,16,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd17),33,16,17,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd18),35,17,18,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd19),37,18,19,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd20),39,19,20,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd21),41,20,21,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd22),43,21,22,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd23),45,22,23,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd24),47,23,24,min_range,max_range);
   RunRangeScan(iBarShift(NULL,0,spd25),49,24,25,min_range,max_range);
  }
//+----------------------------------------+
//  Run BAR scan                           |
//+----------------------------------------+
void RunBARscan()
//+----------------------------------------+
  {
   CurrentBoxType = 11;
   LastBoxType = 11;
   
   double currentboxhigh = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE1);
   double currentboxlow  = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE2);
   double lastboxhigh    = ObjectGet("MagicBox"+IntegerToString(box_No-1),OBJPROP_PRICE1);
   double lastboxlow     = ObjectGet("MagicBox"+IntegerToString(box_No-1),OBJPROP_PRICE2);
   double previousboxhigh= ObjectGet("MagicBox"+IntegerToString(box_No-2),OBJPROP_PRICE1);
   double previousboxlow = ObjectGet("MagicBox"+IntegerToString(box_No-2),OBJPROP_PRICE2);


   if(currentboxhigh>lastboxhigh && currentboxlow<lastboxlow) CurrentBoxType=1001;
   if(currentboxhigh<lastboxhigh && currentboxlow>lastboxlow) CurrentBoxType=1010;
   if(currentboxhigh>lastboxhigh && currentboxlow>lastboxlow) CurrentBoxType=1011;
   if(currentboxhigh<lastboxhigh && currentboxlow<lastboxlow) CurrentBoxType=1100;
   if(currentboxlow>lastboxhigh) CurrentBoxType=1101;
   if(currentboxhigh<lastboxlow) CurrentBoxType=1111;

   if(lastboxhigh>previousboxhigh && lastboxlow<previousboxlow) LastBoxType=1001;
   if(lastboxhigh<previousboxhigh && lastboxlow>previousboxlow) LastBoxType=1010;
   if(lastboxhigh>previousboxhigh && lastboxlow>previousboxlow) LastBoxType=1011;
   if(lastboxhigh<=previousboxhigh && lastboxlow<previousboxlow) LastBoxType=1100;
   if(lastboxlow>previousboxhigh) LastBoxType=1101;
   if(lastboxhigh<previousboxlow) LastBoxType=1111;

   if(LastBoxType==1011 && CurrentBoxType==1100) bool patternA = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrRed);
   if(LastBoxType==1011 && CurrentBoxType==1111) bool patternB = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrOrange);
   if(LastBoxType==1100 && CurrentBoxType==1011) bool patternC = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrYellow);
   if(LastBoxType==1100 && CurrentBoxType==1101) bool patternD = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrLimeGreen);
   if(LastBoxType==1101 && CurrentBoxType==1100) bool patternE = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrGreen);
   if(LastBoxType==1101 && CurrentBoxType==1111) bool patternF = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrAqua);
   if(LastBoxType==1111 && CurrentBoxType==1011) bool patternG = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrMediumBlue);
   if(LastBoxType==1111 && CurrentBoxType==1101) bool patternH = ObjectSet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR,clrViolet);
  }
//+----------------------------------------+
//  Look For Active Trade Box              |
//+----------------------------------------+
void LookForActiveTradeBox()
//+----------------------------------------+
  {
   color boxcolor = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_COLOR);

   if(boxcolor==clrGreen)
     {
      double currentboxhigh = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE1);
      double currentboxlow  = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE2);

      if(Bid>currentboxhigh)
        {
         NewTradeBoxFormed=false;
         GoLongIntoMarket(currentboxhigh,currentboxlow);
        }

      if(Bid<currentboxlow)
        {
         NewTradeBoxFormed=false;
         GoShortIntoMarket(currentboxhigh,currentboxlow);
        }
     }

  }
//+----------------------------------------+
//  Run Range scan                         |
//+----------------------------------------+
void RunRangeScan(int index,int boxspread,int run_leg,int boxNo,double Min,double Max)
//+----------------------------------------+
  {
   if(index>boxspread)
     {
      for(int i=index;i>0;i--)
        {
         bool valid=true;
         int bc=0;

         int    BoxHS  = iHighest(NULL,0,MODE_HIGH,run_leg,i);
         int    BoxLS  = iLowest (NULL,0,MODE_LOW,run_leg,i);
         int    LeftT  = MathMax(BoxHS,BoxLS);
         int    RightT = MathMin(BoxHS,BoxLS);

         double BoxH   =   High[BoxHS];
         double BoxH1  = High[BoxHS+1];
         double BoxH2  = High[BoxHS+2];
         double BoxH3  = High[BoxHS+3];
         double BoxL   =    Low[BoxLS];
         double BoxL1  =  Low[BoxLS+1];
         double BoxL2  =  Low[BoxLS+2];
         double BoxL3  =  Low[BoxLS+3];

         if((BoxH-BoxL<=Min) || 
            (BoxH-BoxL>Max) || 
            (LeftT==BoxHS && BoxH1>BoxH) ||
            (LeftT==BoxHS && BoxH2>BoxH) ||
            (LeftT==BoxHS && BoxH3>BoxH) ||
            (LeftT==BoxLS && BoxL1<BoxL) ||
            (LeftT==BoxLS && BoxL2<BoxL) ||
            (LeftT==BoxLS && BoxL3<BoxL))
           {
            if(boxNo==2) spd2=Time[i];
            else if(boxNo==3)   spd3=Time[i];
            else if(boxNo==4)   spd4=Time[i];
            else if(boxNo==5)   spd5=Time[i];
            else if(boxNo==6)   spd6=Time[i];
            else if(boxNo==7)   spd7=Time[i];
            else if(boxNo==8)   spd8=Time[i];
            else if(boxNo==9)   spd9=Time[i];
            else if(boxNo==10) spd10=Time[i];
            else if(boxNo==11) spd11=Time[i];
            else if(boxNo==12) spd12=Time[i];
            else if(boxNo==13) spd13=Time[i];
            else if(boxNo==14) spd14=Time[i];
            else if(boxNo==15) spd15=Time[i];
            else if(boxNo==16) spd16=Time[i];
            else if(boxNo==17) spd17=Time[i];
            else if(boxNo==18) spd18=Time[i];
            else if(boxNo==19) spd19=Time[i];
            else if(boxNo==20) spd20=Time[i];
            else if(boxNo==21) spd21=Time[i];
            else if(boxNo==22) spd22=Time[i];
            else if(boxNo==23) spd23=Time[i];
            else if(boxNo==24) spd24=Time[i];
            else if(boxNo==25) spd25=Time[i];

            continue;
           }

         for(int x=i-1;x>0;x--)
           {
            if((High[x]>BoxH) || (Low[x]<BoxL))
              {
               valid=false;
               break;
              }
            bc++;
           }

         if(valid && bc>=run_leg)
           {
            double currentboxhigh = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE1);
            double currentboxlow  = ObjectGet("MagicBox"+IntegerToString(box_No),OBJPROP_PRICE2);

            if(currentboxhigh>BoxH && currentboxlow<BoxL) break;

            NewTradeBoxFormed=true;

            if(currentboxhigh==BoxH || currentboxlow==BoxL) deleteanddrawbox("MagicBox"+IntegerToString(box_No),Time[LeftT],BoxH,Time[0],BoxL,Box_Colour,Box_Width);
            else
              {
               box_No++;
               drawBox("MagicBox"+IntegerToString(box_No),Time[LeftT],BoxH,Time[0],BoxL,Box_Colour,Box_Width);
              }
            RunBARscan();
            
            break;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|   Set first order to go long into market                         |
//+------------------------------------------------------------------+
void GoLongIntoMarket(double high,double low)
//+------------------------------------------------------------------+
{
 double lot            = 0.01;
 double volatility     = high-low;
 double n_value        = ((volatility * N_Factor)/Point)*MarketInfo(Symbol(),MODE_TICKVALUE);
 double risk           = AccountBalance()*(Risk / 100);
 double tradevolume    = risk /n_value;
 
 if(tradevolume > lot) lot = tradevolume;
 if(Use_Fixed_Lot) lot = Fixed_Lot_Size;

 double price          = Ask;
 double StopLoss       = high-(volatility*N_Factor);
 double TakeProfit     = high +(volatility*Reward);
 
 int OpenLong = OrderSend(Symbol(),OP_BUY,lot,price,Slippage,StopLoss,TakeProfit,NULL,Magic_No,0,Blue);
  
 NewTradeBoxFormed    = false;
} 
//+------------------------------------------------------------------+
//|   Set first order to go short into market                        |
//+------------------------------------------------------------------+
void GoShortIntoMarket(double high,double low)
//+------------------------------------------------------------------+
{
 double lot            = 0.01;
 double volatility     = high-low;
 double n_value        = ((volatility * N_Factor)/Point)*MarketInfo(Symbol(),MODE_TICKVALUE);
 double risk           = AccountBalance()*(Risk / 100);
 double tradevolume    = risk /n_value;
 
 if(tradevolume > lot) lot = tradevolume;
 if(Use_Fixed_Lot) lot = Fixed_Lot_Size;

 double price          = Bid;
 double StopLoss       = low+(volatility*N_Factor);
 double TakeProfit     = low-(volatility*Reward);
 
 int OpenShort = OrderSend(Symbol(),OP_SELL,lot,price,Slippage,StopLoss,TakeProfit,NULL,Magic_No,0,Red);
  
 NewTradeBoxFormed    = false;
}    
//+----------------------------------------+
//  Function Master Box                    |
//+----------------------------------------+

//+----------------------------------------+
//{
//---Reset variables

//---Initiate Function variables

//---Function Logic

//---Variable adjustments

//}

//+----------------------------------------+
//  Delete and Draw box                    |
//+----------------------------------------+
void deleteanddrawbox(string name,datetime time1,double price1,datetime time2,double price2,color clr,int width)
//+----------------------------------------+
  {
   ObjectDelete(name);
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+----------------------------------------+
//  Draw box                               |
//+----------------------------------------+
void drawBox(string name,datetime time1,double price1,datetime time2,double price2,color clr,int width)
//+----------------------------------------+
  {
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

  }
//+------------------------------------------------------------------+
